<template>
  <b-form-input
    v-model="object.value"
    class="formgeneratordatepicker"
    :locale="languageCode"
    :disabled="disabledMode || locked"
    :required="required"
    type="date"
    :state="state"
    @update:model-value="updateMetadataValue"
  />
</template>

<script lang="ts">
import type { NamedNode, Quad_Object } from '@rdfjs/types';
import factory from 'rdf-ext';
import prefixes from '@zazuko/prefixes/prefixes';

export default defineComponent({
  name: 'InputDatePicker',
  props: {
    languageCode: {
      default: 'en',
      type: String,
    },
    locked: {
      default: false,
      type: Boolean,
    },
    required: {
      default: false,
      type: Boolean,
    },
    entry: {
      required: true,
      type: Object as PropType<Quad_Object>,
    },
    dataType: {
      default: () => factory.namedNode(prefixes.xsd + 'date'),
      type: Object as PropType<NamedNode<string>>,
    },
    disabledMode: {
      default: false,
      type: Boolean,
    },
    state: {
      type: [Boolean] as PropType<boolean | null>,
      default: null,
    },
  },
  data() {
    return {
      object: factory.literal('', this.dataType),
    };
  },
  watch: {
    entry() {
      this.loadData();
    },
  },
  mounted() {
    this.loadData();
    // take whatever is defined in metadata now and try to get the content if we are not in fixed value mode
    this.replacePlaceholder();
  },
  methods: {
    loadData() {
      if (this.object.value !== this.entry.value) {
        // 10 character cutoff to deal with longer invalid date formats
        this.object.value = this.entry.value.substring(0, 10);
      }
    },
    replacePlaceholder() {
      if (this.entry.value === '{TODAY}') {
        const today = new Date();
        const dd = String(today.getDate()).padStart(2, '0');
        const mm = String(today.getMonth() + 1).padStart(2, '0'); // January is 0!
        const yyyy = today.getFullYear();
        this.object.value = yyyy + '-' + mm + '-' + dd;

        this.$emit('update:metadata-value', this.object);
        this.$emit('triggerValidation');
      }
    },
    updateMetadataValue() {
      this.$emit('update:metadata-value', this.object);
    },
  },
});
</script>

<style scoped>
.formgeneratordatepicker :deep(label) {
  display: flex;
  align-items: center;
}
.formgeneratordatepicker :deep(div.is-valid) {
  background-image: unset;
}
.formgeneratordatepicker :deep(footer) {
  display: none;
}
.formgeneratordatepicker :deep(button) {
  min-width: unset;
  margin: unset;
}
.formgeneratordatepicker :deep(.b-calendar button) {
  min-width: unset;
}
</style>
